using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Topic04
{
    public class ThreadControlSingleton : IDisposable
    {
        public delegate void ProcDelegate();

        // oϐ
        public ProcDelegate Proc = null;
        private static ThreadControlSingleton _instance = null;
        private Thread _thread = null;

        // RXgN^
        private ThreadControlSingleton()
        {
            _thread = new Thread(ThreadProc);
        }

        // vpeB
        public static ThreadControlSingleton Instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new ThreadControlSingleton();
                }
                return _instance;
            }
        }

        public void Dispose()
        {
            _thread.Abort();
            _thread = null;
        }

        public void ThreadStart()
        {
            if (_thread.ThreadState == ThreadState.Stopped)
            {
                _thread.Abort();
                _thread = new Thread(ThreadProc);
            }
            _thread.Start();
        }

        private void ThreadProc()
        {
            if (Proc != null)
            {
                Proc();
            }
        }
    }
}
